HDU1072 Nightmare 【BFS】

Nightmare

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 7367    Accepted Submission(s): 3530

Problem Description

Ignatius had a nightmare last night. He found himself in a labyrinth with a time bomb on him. The labyrinth has an exit, Ignatius should get out of the labyrinth before the bomb explodes. The initial exploding time of the bomb is
set to 6 minutes. To prevent the bomb from exploding by shake, Ignatius had to move slowly, that is to move from one area to the nearest area(that is, if Ignatius stands on (x,y) now, he could only on (x+1,y), (x-1,y), (x,y+1), or (x,y-1) in the next minute)
takes him 1 minute. Some area in the labyrinth contains a Bomb-Reset-Equipment. They could reset the exploding time to 6 minutes.

Given the layout of the labyrinth and Ignatius‘ start position, please tell Ignatius whether he could get out of the labyrinth, if he could, output the minimum time that he has to use to find the exit of the labyrinth, else output -1.

Here are some rules:

1. We can assume the labyrinth is a 2 array.

2. Each minute, Ignatius could only get to one of the nearest area, and he should not walk out of the border, of course he could not walk on a wall, too.

3. If Ignatius get to the exit when the exploding time turns to 0, he can‘t get out of the labyrinth.

4. If Ignatius get to the area which contains Bomb-Rest-Equipment when the exploding time turns to 0, he can‘t use the equipment to reset the bomb.

5. A Bomb-Reset-Equipment can be used as many times as you wish, if it is needed, Ignatius can get to any areas in the labyrinth as many times as you wish.

6. The time to reset the exploding time can be ignore, in other words, if Ignatius get to an area which contain Bomb-Rest-Equipment, and the exploding time is larger than 0, the exploding time would be reset to 6.

Input

The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.

Each test case starts with two integers N and M(1<=N,Mm=8) which indicate the size of the labyrinth. Then N lines follow, each line contains M integers. The array indicates the layout of the labyrinth.

There are five integers which indicate the different type of area in the labyrinth:

0: The area is a wall, Ignatius should not walk on it.

1: The area contains nothing, Ignatius can walk on it.

2: Ignatius‘ start position, Ignatius starts his escape from this position.

3: The exit of the labyrinth, Ignatius‘ target position.

4: The area contains a Bomb-Reset-Equipment, Ignatius can delay the exploding time by walking to these areas.

Output

For each test case, if Ignatius can get out of the labyrinth, you should output the minimum time he needs, else you should just output -1.

Sample Input

3
3 3
2 1 1
1 1 0
1 1 3
4 8
2 1 1 0 1 1 1 0
1 0 4 1 1 0 4 1
1 0 0 0 0 0 0 1
1 1 1 4 1 1 1 3
5 8
1 2 1 1 1 1 1 4
1 0 0 0 1 0 0 1
1 4 1 0 1 1 0 1
1 0 0 0 0 3 0 1
1 1 4 1 1 1 1 1 

Sample Output

4
-1
13

Author

Ignatius.L

题意:给定一张n行m列的地图,其中1代表空地,2代表入口,3代表出口,4代表炸弹时间重置点,炸弹时间初始化时是6秒,每次移动只能是上下左右相邻的格子,每次耗时1秒,0秒时炸弹立刻爆炸,即便到达出口或者重置点也没用,求从入口达到出口所花最少时间,如果出不来输出-1。

题解:用广搜解,由于数据量较少,不需要重复的状态标记,但是为了避免死循环,时间重置点只能用1次,用完后将其标记成空地。

#include <stdio.h>
#include <string.h>
#include <queue>

#define maxn 10

int G[maxn][maxn], n, m;
struct Node {
	int x, y, time, leftTime;
} S;
const int mov[][2] = {0, 1, 0, -1, 1, 0, -1, 0};

void getMap() {
	scanf("%d%d", &n, &m);
	int i, j;
	for(i = 1; i <= n; ++i)
		for(j = 1; j <= m; ++j) {
			scanf("%d", &G[i][j]);
			if(G[i][j] == 2) {
				S.x = i; S.y = j;
				S.time = 0; S.leftTime = 6;
			}
		}
}

bool check(int x, int y) {
	if(x < 1 || x > n || y < 1 || y > m)
		return false;
	if(G[x][y] == 0) return false;
	return true;
}

int BFS() {
	int i, j, x, y;
	std::queue<Node> Q;
	Q.push(S);
	Node now, tmp;

	while(!Q.empty()) {
		now = Q.front(); Q.pop();
		for(i = 0; i < 4; ++i) {
			x = mov[i][0] + now.x;
			y = mov[i][1] + now.y;
			if(check(x, y)) {
				tmp = now; ++tmp.time;
				if(--tmp.leftTime) {
					if(G[x][y] == 4) {
						tmp.leftTime = 6;
						G[x][y] = 1;
					} else if(G[x][y] == 3)
						return tmp.time;
					tmp.x = x; tmp.y = y;
					Q.push(tmp);
				}
			}
		}
	}

	return -1;
}

void solve() {
	printf("%d\n", BFS());
}

int main() {
	// freopen("stdin.txt", "r", stdin);
	int t;
	scanf("%d", &t);
	while(t--) {
		getMap();
		solve();
	}
	return 0;
}

带vis标记的解法:

#include <stdio.h>
#include <string.h>
#include <queue>

#define maxn 10

int G[maxn][maxn], n, m;
struct Node {
	int x, y, time, leftTime;
} S;
const int mov[][2] = {0, 1, 0, -1, 1, 0, -1, 0};
bool vis[maxn][maxn][8];

void getMap() {
	scanf("%d%d", &n, &m);
	int i, j;
	for(i = 1; i <= n; ++i)
		for(j = 1; j <= m; ++j) {
			scanf("%d", &G[i][j]);
			if(G[i][j] == 2) {
				S.x = i; S.y = j;
				S.time = 0; S.leftTime = 6;
			}
		}
}

bool check(int x, int y) {
	if(x < 1 || x > n || y < 1 || y > m)
		return false;
	if(G[x][y] == 0) return false;
	return true;
}

int BFS() {
	int i, j, x, y;
	std::queue<Node> Q;
	Q.push(S);
	Node now, tmp;
	memset(vis, 0, sizeof(vis));
	vis[S.x][S.y][S.leftTime] = 1;
	while(!Q.empty()) {
		now = Q.front(); Q.pop();
		for(i = 0; i < 4; ++i) {
			x = mov[i][0] + now.x;
			y = mov[i][1] + now.y;
			tmp = now;
			if(check(x, y) && !vis[x][y][--tmp.leftTime]) {
				++tmp.time;
				if(tmp.leftTime) {
					if(G[x][y] == 4) {
						tmp.leftTime = 6;
						G[x][y] = 1;
					} else if(G[x][y] == 3)
						return tmp.time;
					tmp.x = x; tmp.y = y;
					vis[x][y][tmp.leftTime] = 1;
					Q.push(tmp);
				}
			}
		}
	}

	return -1;
}

void solve() {
	printf("%d\n", BFS());
}

int main() {
	// freopen("stdin.txt", "r", stdin);
	int t;
	scanf("%d", &t);
	while(t--) {
		getMap();
		solve();
	}
	return 0;
}
时间: 2024-10-13 21:24:41

HDU1072 Nightmare 【BFS】的相关文章

hdoj 1072 Nightmare 【bfs】

Nightmare Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8568    Accepted Submission(s): 4107 Problem Description Ignatius had a nightmare last night. He found himself in a labyrinth with a ti

【bfs】【中等难度】tyvj P1234 - bench与奔驰

P1234 - bench与奔驰 From zhangbh001    Normal (OI) 总时限:10s    内存限制:128MB    代码长度 限制:64KB P1234 - bench与奔驰 背景 Background 公园里有个人在练开奔驰 - -!,但是总是撞在bench上 (众人曰:狼来了,快跑啊!) 描述 Description 公园里的bench与奔驰都是无敌的,不会被撞坏.由于开奔驰的人比较"有特点",总是向上下左右四个方向开,而且只会在撞到椅子之后改变方向(

hdoj 1312 Red and Black 【BFS】

题意:一共有四个方向,从'@'出发,找能到达'.'的个数, #是不能通过的. 策略:广搜. 这道题属于最简单的bfs了. 代码: #include<stdio.h> #include<string.h> #include<queue> using std::queue; bool vis[25][25]; char s[25][25]; int n, m; int ans = 0; struct node{ int x, y; }; node st; const int

HDU1242 Rescue 【BFS】

Rescue Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 16314    Accepted Submission(s): 5926 Problem Description Angel was caught by the MOLIGPY! He was put in prison by Moligpy. The prison is

HDU 1253 胜利大逃亡 NYOJ 523【BFS】

胜利大逃亡 Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 24608    Accepted Submission(s): 9427 Problem Description Ignatius被魔王抓走了,有一天魔王出差去了,这可是Ignatius逃亡的好机会. 魔王住在一个城堡里,城堡是一个A*B*C的立方体,可以被表示成A个B*C的

NYOJ 284 坦克大战 【BFS】+【优先队列】

坦克大战 时间限制:1000 ms  |  内存限制:65535 KB 难度:3 描述 Many of us had played the game "Battle city" in our childhood, and some people (like me) even often play it on computer now. What we are discussing is a simple edition of this game. Given a map that co

【BFS】uva10047The Monocycle

/* 本题的特殊之处,到达一个格子时,因为朝向不同,以及接触地面的颜色不同, 会处于不同的状态::::::::: 把(x, y, d, c)作为一个结点,表示所在位置(x, y),方向为d,颜色为c;;;;; ------------------------------------------------------------------------ 在方向上我们把前,左,右编号为0,1,2:::: 颜色,从蓝色开始编号为0,1,2,3:::::::::: ------------------

【BFS】uva11624Fire!

/* bfs宽度遍历 -------------------------------------------------------------------------- 对人和火同时进行bfs,,注意应该先火后人,即如果在人到达该格子前,格子已经着火 则不应该走,最后人走到边界无路可走,则IMPOSSIBLE!!!!!!!!!!!! --------------------------------------------------------------------------- 两次bfs

【bfs】hdu 1104 Remainder

[bfs]hdu 1104 Remainder 题目链接:hdu 1104 Remainder 很不错的一道搜索题目,但是有几个关键问题要注意. 最短路径,果断bfs+Queue 路径的存储问题,之前只想把每一步的计算结果存储到queue(int)Q中,后来发现路径无法记录,就选择存储节点的方式并用string保存路径,queue(node)Q,开一个临时的节点node p,每进行一次运算就更新它的路径string+'op',最终输出的一定是完整路径!! 但最关键的是取模!!!!! discus